added python-cinderclient to openmano installer
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
40 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
41 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
42 }
43
44 function install_packages(){
45 [ -x /usr/bin/apt-get ] && apt-get install -y $*
46 [ -x /usr/bin/yum ] && yum install -y $*
47
48 #check properly installed
49 for PACKAGE in $*
50 do
51 PACKAGE_INSTALLED="no"
52 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 if [ "$PACKAGE_INSTALLED" = "no" ]
55 then
56 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
57 exit 1
58 fi
59 done
60 }
61
62 function db_exists() {
63 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
64 if [ "$RESULT" == "$1" ]; then
65 echo " DB $1 exists"
66 return 0
67 fi
68 echo " DB $1 does not exist"
69 return 1
70 }
71
72 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
73 DBUSER="root"
74 DBPASSWD=""
75 DBPASSWD_PARAM=""
76 QUIET_MODE=""
77 DEVELOP=""
78 FORCEDB=""
79 FORCE=""
80 NOCLONE=""
81 NO_PACKAGES=""
82 while getopts ":u:p:hiq-:" o; do
83 case "${o}" in
84 u)
85 export DBUSER="$OPTARG"
86 ;;
87 p)
88 export DBPASSWD="$OPTARG"
89 export DBPASSWD_PARAM="-p$OPTARG"
90 ;;
91 q)
92 export QUIET_MODE=yes
93 export DEBIAN_FRONTEND=noninteractive
94 ;;
95 h)
96 usage && exit 0
97 ;;
98 -)
99 [ "${OPTARG}" == "help" ] && usage && exit 0
100 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
101 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
102 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
103 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
104 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
105 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
106 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
107 exit 1
108 ;;
109 \?)
110 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
111 exit 1
112 ;;
113 :)
114 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
115 exit 1
116 ;;
117 *)
118 usage >&2
119 exit 1
120 ;;
121 esac
122 done
123
124 #check root privileges and non a root user behind
125 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
126 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
127 then
128 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
129 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
130 export SUDO_USER=root
131 fi
132
133 #Discover Linux distribution
134 #try redhat type
135 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
136 #if not assuming ubuntu type
137 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
138 if [ "$_DISTRO" == "Ubuntu" ]
139 then
140 _RELEASE=$(lsb_release -rs)
141 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
142 then
143 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
144 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
145 _RELEASE = 14
146 fi
147 elif [ "$_DISTRO" == "CentOS" ]
148 then
149 _RELEASE="7"
150 if ! cat /etc/redhat-release | grep -q "7."
151 then
152 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
153 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
154 fi
155 elif [ "$_DISTRO" == "Red" ]
156 then
157 _RELEASE="7"
158 if ! cat /etc/redhat-release | grep -q "7."
159 then
160 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
161 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
162 fi
163 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
164 _DISTRO_DISCOVER=$_DISTRO
165 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
166 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
167 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
168 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
169 fi
170
171 #check if installed as a service
172 INSTALL_AS_A_SERVICE=""
173 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
174 #Next operations require knowing OPENMANO_BASEFOLDER
175 if [[ -z "$NOCLONE" ]]; then
176 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
177 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
178 else
179 OPENMANO_BASEFOLDER="${PWD}/openmano"
180 fi
181 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
182 else
183 HERE=$(realpath $(dirname $0))
184 OPENMANO_BASEFOLDER=$(dirname $HERE)
185 fi
186
187
188 if [[ -z "$NO_PACKAGES" ]]
189 then
190 echo '
191 #################################################################
192 ##### UPDATE REPOSITORIES #####
193 #################################################################'
194 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
195
196 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
197 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
198 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
199 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
200 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
201
202 fi
203
204 if [[ -z "$NO_PACKAGES" ]]
205 then
206 echo '
207 #################################################################
208 ##### INSTALL REQUIRED PACKAGES #####
209 #################################################################'
210 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
211 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
212
213 if [[ "$_DISTRO" == "Ubuntu" ]]
214 then
215 #start services. By default CentOS does not start services
216 service mysql start >> /dev/null
217 # try to set admin password, ignore if fails
218 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
219 fi
220
221 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
222 then
223 #start services. By default CentOS does not start services
224 service mariadb start
225 service httpd start
226 systemctl enable mariadb
227 systemctl enable httpd
228 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
229 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
230
231 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
232 [ "$KK" != "n" -a "$KK" != "no" ] &&
233 firewall-cmd --permanent --zone=public --add-service=http &&
234 firewall-cmd --permanent --zone=public --add-service=https &&
235 firewall-cmd --reload
236 fi
237 fi #[[ -z "$NO_PACKAGES" ]]
238
239 #check and ask for database user password. Must be done after database installation
240 if [[ -n $QUIET_MODE ]]
241 then
242 echo -e "\nCheking database connection and ask for credentials"
243 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
244 do
245 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
246 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
247 read -e -p "database user? ($DBUSER) " DBUSER_
248 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
249 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
250 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
251 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
252 logintry="yes"
253 done
254 fi
255
256 if [[ -z "$NO_PACKAGES" ]]
257 then
258 echo '
259 #################################################################
260 ##### INSTALL PYTHON PACKAGES #####
261 #################################################################'
262 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
263 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
264
265 #required for vmware connector TODO move that to separete opt in install script
266 sudo pip install --upgrade pip
267 sudo pip install pyvcloud
268 sudo pip install progressbar
269 sudo pip install prettytable
270
271 #The only way to install python-bottle on Centos7 is with easy_install or pip
272 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
273
274 #install openstack client needed for using openstack as a VIM
275 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
276 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
277 fi #[[ -z "$NO_PACKAGES" ]]
278
279 if [[ -z $NOCLONE ]]; then
280 echo '
281 #################################################################
282 ##### DOWNLOAD SOURCE #####
283 #################################################################'
284 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
285 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
286 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.0.2"
287 fi
288
289 echo '
290 #################################################################
291 ##### CREATE DATABASE #####
292 #################################################################'
293 echo -e "\nCreating temporary file form MYSQL installation and initialization"
294 TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
295 trap 'rm -f "$TEMPFILE"' EXIT
296 chmod 0600 "$TEMPFILE"
297 echo -e "[client]\n user='$DBUSER'\n password='$DBPASSWD'">"$TEMPFILE"
298
299 if db_exists "mano_db" $TEMPFILE ; then
300 if [[ -n $FORCEDB ]]; then
301 echo " Deleting previous database mano_db"
302 DBDELETEPARAM=""
303 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
304 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
305 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
306 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
307 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
308 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
309 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
310 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
311 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
312 else
313 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
314 fi
315 else
316 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
317 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
318 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
319 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
320 fi
321
322
323 echo '
324 #################################################################
325 ##### INIT DATABASE #####
326 #################################################################'
327 su $SUDO_USER -c "${OPENMANO_BASEFOLDER}/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db" || ! echo "Failed while initializing database" || exit 1
328
329
330 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
331 then
332 echo '
333 #################################################################
334 ##### CONFIGURE firewalld #####
335 #################################################################'
336 KK=yes
337 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
338 if [ "$KK" != "n" -a "$KK" != "no" ]
339 then
340 #Creates a service file for openmano
341 echo '<?xml version="1.0" encoding="utf-8"?>
342 <service>
343 <short>openmanod</short>
344 <description>openmanod service</description>
345 <port protocol="tcp" port="9090"/>
346 </service>' > /etc/firewalld/services/openmanod.xml
347 #put proper permissions
348 pushd /etc/firewalld/services > /dev/null
349 restorecon openmanod.xml
350 chmod 640 openmanod.xml
351 popd > /dev/null
352 #Add the openmanod service to the default zone permanently and reload the firewall configuration
353 firewall-cmd --permanent --add-service=openmanod > /dev/null
354 firewall-cmd --reload > /dev/null
355 echo "done."
356 else
357 echo "skipping."
358 fi
359 fi
360
361 echo '
362 #################################################################
363 ##### CONFIGURE OPENMANO CLIENT #####
364 #################################################################'
365 #creates a link at ~/bin if not configured as a service
366 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
367 then
368 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
369 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
370 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
371 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
372 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
373 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
374 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
375
376 #insert /home/<user>/bin in the PATH
377 #skiped because normally this is done authomatically when ~/bin exist
378 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
379 #then
380 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
381 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
382 #fi
383 if [[ $SUDO_USER == root ]]
384 then
385 if ! echo $PATH | grep -q "${HOME}/bin"
386 then
387 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
388 fi
389 fi
390 fi
391
392 #configure arg-autocomplete for this user
393 #in case of minimal instalation this package is not installed by default
394 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
395 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
396 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
397 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
398 then
399 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
400 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
401 fi
402
403
404
405
406 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
407 then
408 echo '
409 #################################################################
410 ##### CONFIGURE OPENMANO SERVICE #####
411 #################################################################'
412
413 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
414 # rm -rf ${OPENMANO_BASEFOLDER}
415 # alias service-openmano="service openmano"
416 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
417
418 echo
419 echo "Done! installed at /opt/openmano"
420 echo " Manage server with 'sudo service openmano start|stop|status|...' "
421
422
423 else
424
425 echo
426 echo "Done! you may need to logout and login again for loading client configuration"
427 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
428
429 fi
430
431
432